/*
 *  qrb.c - computing distance between two locators
 *  Copyright (c)2002 - 2004 Andrej  OM1CW
 *  Copyright (c)2005 Mike Karas OM4AA <mike.om4aa@gmail.com>
 *  Copyright (c)2009 Ladislav Vaiz OK1ZIA <ok1zia@nagano.cz>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "osdep.h"
#include "debug.h"
#include "qrb.h"


//#define PI 3.1415927

#if 0
double acs(/*uint32_t*/ double arg)
{
	DEBUG_FUNC("acs");

	if (arg == 0)
		return (MY_PI / 2);
	else if (arg < 0)
		return (MY_PI + atan(sqrt(1 - arg * arg) / arg));
	else
		return (atan(sqrt(1 - arg * arg) / arg));
}
#endif

double dely(uint32_t num) /* y */
{
	DEBUG_FUNC("delx");

	return (((double) (10 * ((num >> 18) & 0x1F) + ((num >> 10) & 0x0F) +
					   (((double) (num & 0x1F))+0.5) / 24)) * MY_PI / 180);
	/* (((double) (10 * (loc[1] - 'A') + (loc[3] - '0') + ((double) (loc[5] - 'A')) / 24))
	   * MY_PI / 180); */
}

double delx(uint32_t num) /* x */
{
	DEBUG_FUNC("dely");

	return (((double)
			 (20 * ((num >> 23) & 0x1F) + 2 * ((num >> 14) & 0x0F) +
			  (((double) ((num >> 5) & 0x1F))+0.5) / 12)) * MY_PI / 180);
	/* (((double) (20 * (loc[0] - 'A') + 2 * (loc[2] - '0') + ((double) (loc[4] - 'A')) / 12))
	   * MY_PI / 180); */
}

uint32_t QRB(uint32_t loc1, uint32_t loc2)
{
	DEBUG_FUNC("QRB");

	if (loc1 == loc2)
		return 1;

	double x1= delx(loc1);
	double y1= dely(loc1);
	double x2 = delx(loc2);
	double y2 = dely(loc2);

	if (!(loc1 & 0x80000000))
		return 0;
	if (!(loc2 & 0x80000000))
		return 0;

	double dis = /*6365*/ R_EARTH * acos(cos(y1) * cos(y2) + sin(y1) * sin(y2) * cos(x2 - x1));

/*	double zv = dis - floor(dis);

	if (zv > 0.5 && zv != 0)
		dis++;*/
		
	int points = (int) (dis + 1.0); /* distance to points rounding - as specified by IARU */

/* printf("x1=%7.8f, y1=%7.8f, x2=%7.8f, y2=%7.8f, points=%u, qrb=%7.2f\n", x1, y1, x2, y2, points, dis); */
//	return (uint32_t) dis;			/* FIXME: need better type conversion ??? */
	return points;
}
